/* global ciberprotector */

(function($) {
  // ------------- CONFIG -------------
  var toastTime = 5000;

  // ------------- VARIABLES -------------
  var showQRBtn = $(".js-ciberprotector-show-qr-button"),
    QRWrapper = $(".js-ciberprotector-qr-wrapper"),
    reloadQRBtn = $(".js-ciberprotector-reload-qr-button"),
    QRimage = $(".js-ciberprotector-qr-image"),
    privateKeyValue = $(".js-ciberprotector-private-key-value"),
    privateKeyElement = $(".js-ciberprotector-private-key"),
    showPrivateKeyLink = $(".js-ciberprotector-show-private-key"),
    notificationsWrapper = $(".js-ciberprotector-notifications"),
    totpSecretInput = $(".js-ciberprotector-totp-secret-input"),
    totpForm = $(".js-ciberprotector-totp-form"),
    totpFormSubmitBtn = $(".js-ciberprotector-totp-submit"),
    totpToken = $("#ciberprotector-totp-token"),
    wpNonce = $("#_wpnonce"),
    trustedDevicesWrapper = $(".js-ciberprotector-trusted-devices-wrapper"),
    trustedDeviceRemoveModal = $(
      ".js-ciberprotector-modal-remove-trusted-device"
    ),
    trustedDeviceRemoveConfirm = $(
      ".js-ciberprotector-remove-trusted-device-confirm"
    ),
    totpSwitch = $(".js-ciberprotector-totp-switch"),
    totpSwitchDesc = $(".js-ciberprotector-totp-switch-desc"),
    loginForm = $("#ciberprotector-loginform"),
    wpSubmit = $("#wp-submit"),
    configWrapper = $(".js-ciberprotector-config-wrapper"),
    configWrapperButton = $(".js-ciberprotector-config-wrapper-button"),
    addAnotherDeviceButton = $(".js-ciberprotector-add-another-device"),
    configuredBox = $(".js-ciberprotector-configured-box"),
    configuredParagraph = $(".js-ciberprotector-configured-paragraph"),
    configuringNewParagraph = $(".js-ciberprotector-configuring-new-paragraph"),
    configuredBoxDate = $(".js-ciberprotector-date-content"),
    removeBar = $(".js-ciberprotector-remove-bar"),
    removeConfiguration = $(".js-ciberprotector-remove-config"),
    removeBarForm = $(".js-ciberprotector-remove-bar-form"),
    configBarConfigured = $(".js-ciberprotector-config-bar-configured"),
    configBarNotConfigured = $(".js-ciberprotector-config-bar-not-configured"),
    modalConfirmation = $(".js-ciberprotector-modal-confirmation"),
    modalCancel = $(".js-ciberprotector-modal-cancel"),
    modalConfirm = $(".js-ciberprotector-confirmation-confirm"),
    modalRemoveConfig = $(".js-ciberprotector-modal-remove-config"),
    modalRemoveConfirm = $(".js-ciberprotector-remove-config-confirm"),
    ratePromptBox = $(".js-ciberprotector-rate-plugin-prompt-box"),
    closeRatePromptButton = $(".js-ciberprotector-close-rate-prompt"),
    postponeRatePromptButton = $(".js-ciberprotector-postpone-rate-prompt"),
    modalOpened = false,
    modalOpenedName = "",
    trustedDeviceObj = null,
    trustedDeviceDeviceID = null;

  // ------------- EVENTS -------------
  showQRBtn.click(function(e) {
    showQRimage(e);
  });

  showPrivateKeyLink.click(function(e) {
    showPrivateKey(e);
  });

  reloadQRBtn.click(function() {
    reloadQRCode();
  });

  totpForm.submit(function(e) {
    submitTOTP(e);
  });

  loginForm.submit(function() {
    wpSubmit.prop("disabled", "disabled");
  });

  addAnotherDeviceButton.click(function(e) {
    showConfigWrapper(e);
  });

  removeConfiguration.click(function(e) {
    e.preventDefault();
    showRemoveConfigModal();
  });

  modalRemoveConfirm.click(function(e) {
    e.preventDefault();
    removeBarForm.submit();
  });

  modalCancel.click(function(e) {
    e.preventDefault();
    closeModalConfirmation();
  });

  modalConfirm.click(function(e) {
    reloadQRCodeConfirmed(e);
  });

  closeRatePromptButton.click(function() {
    closeRatePluginPrompt();
  });

  postponeRatePromptButton.click(function() {
    postponeRatePluginPrompt();
  });

  trustedDeviceRemoveConfirm.click(function(e) {
    removeTrustedDevice(e);
  });

  $(document).on(
    "click",
    ".js-ciberprotector-remove-trusted-device",
    openRemoveTrustedDeviceModal
  );
  $(document).on("click", ".js-ciberprotector-totp-switch", totpSwitchToggle);

  $(document).keyup(function(e) {
    if (27 === e.keyCode) {
      closeModalConfirmation();
    }
  });

  $(document).mouseup(function(e) {
    if (modalOpened) {
      modalBackdropHandle(e);
    }
  });

  // ------------- FUNCTIONS -------------
  function showQRimage(e) {
    e.preventDefault();
    QRWrapper.addClass("ciberprotector-qr-show");
  }

  function hideQRimage() {
    QRWrapper.removeClass("ciberprotector-qr-show");
  }

  function setTotpSwitchEnabled() {
    totpSwitch.val("totp_enabled");
    totpSwitchDesc.html(
      "Desactivar la autenticación de Segundo Factor de CiberProtector en este WordPress:"
    );
  }

  function setTotpSwitchDisabled() {
    totpSwitch.val("totp_disabled");
    totpSwitchDesc.html(
      "Activar la autenticación de Segundo Factor de CiberProtector en este WordPress:"
    );
  }

  function closeRatePluginPrompt() {
    ratePromptBox.addClass("closed");

    jQuery.ajax({
      url: ciberprotector.ajax_url,
      type: "post",
      data: {
        page: ciberprotector.ciberprotector_menu_page,
        ciberprotector_action: "ciberprotector-hide-notice",
        action: "ciberprotector_ajax",
        security: wpNonce.val()
      }
    });
  }

  function postponeRatePluginPrompt() {
    ratePromptBox.addClass("closed");

    jQuery.ajax({
      url: ciberprotector.ajax_url,
      type: "post",
      data: {
        page: ciberprotector.ciberprotector_menu_page,
        ciberprotector_action: "ciberprotector-postpone-notice",
        action: "ciberprotector_ajax",
        security: wpNonce.val()
      }
    });
  }

  function showTwofasToast(type, content) {
    var notification,
      notificationObj,
      notificationTimeout = 0;

    notification =
      '<div class="ciberprotector-toast js-ciberprotector-toast ciberprotector-toast-' +
      type +
      '">' +
      '<div class="ciberprotector-toast-content"><p>' +
      content +
      "</p></div></div>";
    notificationObj = notificationsWrapper.append(notification);

    notificationObj = notificationObj.children().last();

    setTimeout(function() {
      notificationObj.addClass("ciberprotector-show");
    }, 100);

    notificationTimeout = setTimeout(function() {
      notificationObj.removeClass("ciberprotector-show");

      setTimeout(function() {
        notificationObj.remove();
      }, 1000);
    }, toastTime);

    notificationObj.click(function() {
      $(this).removeClass("ciberprotector-show");
      clearTimeout(notificationTimeout);

      setTimeout(function() {
        notificationObj.remove();
      }, 1000);
    });
  }

  function showPrivateKey(e) {
    e.preventDefault();
    privateKeyElement.addClass("ciberprotector-show");
  }

  function showRemoveConfig() {
    removeBar.slideDown(500, function() {
      removeBar.removeClass("ciberprotector-non-configured").css("display", "");
    });
  }

  function showConfiguredConfigBar() {
    configBarNotConfigured.slideUp(500, function() {
      configBarNotConfigured
        .removeClass("ciberprotector-show")
        .css("display", "");

      configBarConfigured.slideDown(500, function() {
        configBarConfigured.addClass("ciberprotector-show").css("display", "");
      });
    });
  }

  function setConfiguredBoxDateToNow() {
    var currentTimestampInMs = Math.floor(Date.now() / 1000);
    configuredBoxDate.attr("data-timestamp-to-format", currentTimestampInMs);
    formatLastPairedDeviceTimestamp();
  }

  function showConfiguredBox() {
    setConfiguredBoxDateToNow();
    if (!configuredBox.hasClass("ciberprotector-show")) {
      configuredBox.slideDown(500, function() {
        configuredBox.addClass("ciberprotector-show").css("display", "");
      });
    }
  }

  function closeModalConfirmation() {
    $(modalOpenedName).animate(
      {
        opacity: 0
      },
      250,
      function() {
        $(this)
          .removeClass("ciberprotector-show")
          .css("opacity", "");
        modalOpened = false;
        modalOpenedName = "";
      }
    );
  }

  function modalBackdropHandle(e) {
    var modal;

    if (modalOpened) {
      modal = $(modalOpenedName)
        .find(".ciberprotector-modal")
        .first();

      if (!modal.is(e.target) && 0 === modal.has(e.target).length) {
        closeModalConfirmation();
      }
    }
  }

  function reloadQRCode() {
    modalConfirmation.addClass("ciberprotector-show").animate(
      {
        opacity: 1
      },
      500,
      function() {
        modalOpened = true;
        modalOpenedName = ".js-ciberprotector-modal-confirmation";
      }
    );
  }

  function reloadQRCodeConfirmed(e) {
    e.preventDefault();
    reloadQRBtn.prop("disabled", "disabled");

    closeModalConfirmation();

    QRWrapper.removeClass("ciberprotector-qr-show").addClass(
      "ciberprotector-qr-loading"
    );

    jQuery
      .ajax({
        url: ciberprotector.ajax_url,
        type: "post",
        data: {
          page: ciberprotector.ciberprotector_menu_page,
          ciberprotector_action: "ciberprotector-reload-qr-code",
          action: "ciberprotector_ajax",
          security: wpNonce.val()
        }
      })
      .done(function(response) {
        var totpSecretValue, qrCodeSrc;

        response = JSON.parse(response);
        totpSecretValue = response["ciberprotector_totp_secret"];
        qrCodeSrc = response["ciberprotector_qr_code"];

        QRimage.attr("src", qrCodeSrc);
        privateKeyValue.html(totpSecretValue);
        totpSecretInput.attr("value", totpSecretValue);
      })
      .error(function() {
        showTwofasToast(
          "error",
          "No he podido generar el código QR.<br />Prueba de nuevo."
        );
      })
      .always(function() {
        reloadQRBtn.prop("disabled", false);
        QRWrapper.removeClass("ciberprotector-qr-loading").addClass(
          "ciberprotector-qr-show"
        );
      });
  }

  function submitTOTP(e) {
    var totpTokenValue = totpToken.val(),
      totpSecretValue = totpSecretInput.val();

    e.preventDefault();

    totpFormSubmitBtn.attr("disabled", true);

    jQuery
      .ajax({
        url: ciberprotector.ajax_url,
        type: "post",
        data: {
          page: ciberprotector.ciberprotector_menu_page,
          ciberprotector_action: "ciberprotector-configure-totp",
          action: "ciberprotector_ajax",
          security: wpNonce.val(),
          ciberprotector_totp_secret: totpSecretValue,
          ciberprotector_totp_token: totpTokenValue
        }
      })
      .done(function(response) {
        var result;
        response = JSON.parse(response);
        result = response["ciberprotector_result"];

        if ("success" === result) {
          replaceTrustedDevicesTableHtml(
            response["ciberprotector_trusted_devices"]
          );
          totpToken.val("");

          showTwofasToast(
            "success",
            "Has configurado correctamente la autenticación de segundo factor<br />de CiberProtector."
          );
          hideQRimage();
          hideConfigWrapper();
          showRemoveConfig();
          showConfiguredBox();

          if (!configBarConfigured.hasClass("ciberprotector-show")) {
            showConfiguredConfigBar();
          }

          setTotpSwitchEnabled();
        } else {
          totpToken.val("");
          showTwofasToast(
            "error",
            "El código que has introducido no es válido :(<br />Revisa el código y prueba de nuevo."
          );
        }
      })
      .error(function() {
        showTwofasToast("error", "Algo ha ido mal.<br />Prueba de nuevo!");
      })
      .always(function() {
        totpFormSubmitBtn.attr("disabled", false);
        return false;
      });
  }

  function openRemoveTrustedDeviceModal(e) {
    e.preventDefault();

    trustedDeviceObj = $(this);
    trustedDeviceDeviceID = $(this).attr("data-device");

    trustedDeviceRemoveModal.addClass("ciberprotector-show").animate(
      {
        opacity: 1
      },
      500,
      function() {
        modalOpened = true;
        modalOpenedName = ".js-ciberprotector-modal-remove-trusted-device";
      }
    );
  }

  function removeTrustedDevice(e) {
    e.preventDefault();

    closeModalConfirmation();
    trustedDeviceObj.attr("disabled", true);

    $.ajax({
      url: ciberprotector.ajax_url,
      type: "post",
      data: {
        device_id: trustedDeviceDeviceID,
        page: ciberprotector.ciberprotector_menu_page,
        ciberprotector_action: "ciberprotector-remove-trusted-device",
        action: "ciberprotector_ajax",
        security: wpNonce.val()
      }
    })
      .done(function(response) {
        var result;
        response = JSON.parse(response);
        result = response["ciberprotector_result"];

        if ("success" !== result) {
          return;
        }

        replaceTrustedDevicesTableHtml(
          response["ciberprotector_trusted_devices"]
        );

        showTwofasToast(
          "success",
          "Se ha eliminado correctamente<br />el dispositivo de confianza"
        );
      })
      .error(function() {
        showTwofasToast(
          "error",
          "No se ha podido eliminar correctamente el dispositivo de confianza.<br />Prueba de nuevo"
        );
      })
      .always(function() {
        trustedDeviceObj.attr("disabled", false);
        trustedDeviceObj = trustedDeviceDeviceID = null;
      });
  }

  function totpSwitchToggle() {
    totpSwitch.attr("disabled", true);

    $.ajax({
      url: ciberprotector.ajax_url,
      type: "post",
      data: {
        page: ciberprotector.ciberprotector_menu_page,
        ciberprotector_action: "ciberprotector-totp-enable-disable",
        action: "ciberprotector_ajax",
        security: wpNonce.val()
      }
    })
      .done(function(response) {
        var status;

        response = JSON.parse(response);

        if ("success" !== response["ciberprotector_result"]) {
          return;
        }

        status = response["ciberprotector_totp_status"];

        if ("totp_enabled" === status) {
          setTotpSwitchEnabled();
        }

        if ("totp_disabled" === status) {
          setTotpSwitchDisabled();
        }
      })
      .error(function() {
        showTwofasToast("error", "Algo ha ido mal.<br />Prueba de nuevo");
      })
      .always(function() {
        totpSwitch.attr("disabled", false);
      });
  }

  function showConfigWrapper(e) {
    e.preventDefault();

    configWrapperButton.slideUp(400, function() {
      configWrapperButton
        .removeClass("ciberprotector-configured")
        .css("display", "");

      configWrapper.slideDown(1500, function() {
        configWrapper
          .removeClass("ciberprotector-configured")
          .css("display", "");
      });
    });

    configuredParagraph.slideUp(400, function() {
      configuredBox.removeClass("ciberprotector-configured");
      configuredParagraph.css("display", "");

      configuringNewParagraph.slideDown(400, function() {
        configuredBox.addClass("ciberprotector-configuring-new");
        configuringNewParagraph.css("display", "");
      });
    });
  }

  function hideConfigWrapper() {
    configWrapper.slideUp(1500, function() {
      configWrapper.addClass("ciberprotector-configured").css("display", "");

      configWrapperButton.slideDown(400, function() {
        configWrapperButton
          .addClass("ciberprotector-configured")
          .css("display", "");
      });
    });

    configuringNewParagraph.slideUp(400, function() {
      configuredBox.removeClass("ciberprotector-configuring-new");
      configuringNewParagraph.css("display", "");

      configuredParagraph.slideDown(400, function() {
        configuredBox.addClass("ciberprotector-configured");
        configuredParagraph.css("display", "");
      });
    });
  }

  function showRemoveConfigModal() {
    modalRemoveConfig.addClass("ciberprotector-show").animate(
      {
        opacity: 1
      },
      500,
      function() {
        modalOpened = true;
        modalOpenedName = ".js-ciberprotector-modal-remove-config";
      }
    );
  }

  function replaceTrustedDevicesTableHtml(html) {
    trustedDevicesWrapper.html(html);
    formatTrustedDeviceAddedOnTimestamps();
  }

  function formatLastPairedDeviceTimestamp() {
    formatDateFromTimestampAttribute(
      configuredBoxDate.filter("[data-timestamp-to-format]")
    );
  }

  function formatTrustedDeviceAddedOnTimestamps() {
    formatDateFromTimestampAttribute(
      trustedDevicesWrapper.find("table tbody [data-timestamp-to-format]")
    );
  }

  function formatDateFromTimestampAttribute(jqCollection) {
    return jqCollection.each(function() {
      var timestampInSeconds = $(this).attr("data-timestamp-to-format");

      if (!timestampInSeconds) {
        return;
      }

      var date = new Date(timestampInSeconds * 1000);
      $(this).text(convertDateToString(date));
    });
  }

  function convertDateToString(date) {
    var yyyy = date.getFullYear(),
      month = padWithZeroIfOneDigit(date.getMonth() + 1),
      dd = padWithZeroIfOneDigit(date.getDate()),
      hh = padWithZeroIfOneDigit(date.getHours()),
      min = padWithZeroIfOneDigit(date.getMinutes()),
      ss = padWithZeroIfOneDigit(date.getSeconds());

    return yyyy + "-" + month + "-" + dd + " " + hh + ":" + min + ":" + ss;
  }

  function padWithZeroIfOneDigit(number) {
    return number < 10 ? "0" + number : number;
  }

  // ------------- PAGE SETUP AFTER LOAD -------------
  formatLastPairedDeviceTimestamp();
  formatTrustedDeviceAddedOnTimestamps();
})(jQuery);
